program VerificaComposto;
uses crt, uprimi;
const DueAlla31 = 2147483648.0; {2^31}
      NProve = 500;
      Num = 10;
var c, f, i, j: integer;
    pr, FTot, CTot: longint;

procedure SimPollard(Num: longint; var count, fattori: integer);
begin
     Inc(count);
     if PollRho(Num) then
     begin
          Inc(fattori);
     end;
end;

begin
    ClrScr;
    Randomize;
    FTot:= 0; CTot:= 0;
    Writeln; Writeln;
    Writeln('Simulazione della tecnica Pollard-Rho per la ricerca di un fattore di un numero');
    Writeln;
    Writeln('Inizio Calcolo - L''operazione potrebbe occupare il sistema per alcuni minuti');
    gotoxy(18,WhereY + 2);
    Writeln('Provati      Trovati       Tasso d''Efficienza');
    Writeln;
    for j:= 1 to Num do
    begin
       c:= 0; f:= 0;
       Write('Prova Num ', j);
       i:= 0;
       repeat
           pr:= Random(MaxInt-1)+1;
           if (MillerRa(pr, 10)) and ((pr mod 2) = 0) and (pr <> 0) then
           begin
                SimPollard(pr, c, f);
                i:= i+1;
           end;
           gotoxy(20, WhereY); write('Prova ', i, '/', NProve*j);
       until i=j*NProve;
       gotoxy(20,WhereY);
       Write(c:4, '         ', f:4);
       Writeln('                  ', ((f / c)*100):5:1,' %');
       CTot:= Ctot + c;
       FTot:= FTot + f;
    end;
    writeln;
    writeln('   Totali : ');
    writeln('Provati: ', CTot);
    Writeln('Trovati: ', FTot);
    Writeln('Tasso di efficienza globale: ', ((FTot / CTot)*100):0:1,' %');
    readln;
end.