program Verifica;
uses crt, UMPrimi, Mathe;

var scelta, j, ind: integer;

Procedure pseudo;
var num: RecNo;
begin
     repeat
        clrscr;
        gotoxy(25,4); Writeln('Verifica di pseudo-primalit');
        writeln; writeln;
        Writeln('Inserisci un numero per controllare se  primo (0 per uscire) > ');
        Write('Num = ');
        ReadNo(Num);
        if CalcCfr(Num) = 0 then exit;
        writeln; Write('Il numero '); WriteNo(Num);
        if pseudoprimo(Num) then writeln('e'' composto')
        else writeln('e'' primo (o pseudoprimo)');
        readln;
     until false;
end;

Procedure Miller;
const s=10;
      DueAllaMenoS=exp(-s*ln(2));
var num: RecNo;

begin
     repeat
           clrscr;
           gotoxy(20,4); Writeln('Verifica di primalit di Miller-Rabin');
           writeln; writeln;
           Writeln('Inserisci un numero per controllare se  primo (0 per uscire)');
           Write('Num = ');

           readNo(num);
           if Not (CalcCfr(Num) = 0) then
           begin
                writeln;
                Write('Il numero '); WriteNo(Num);
                if millerra(num, s) then writeln(' e'' composto')
                else
                begin
                     writeln(' e'' primo');
                     writeln;
                     write('Il margine di errore di tale risultato e'' al piu'' = 2^(-',s, ') = ',dueAllaMenoS:6:7);
                end;
                readln;
           end;
     until CalcCfr(Num) = 0;
end;

Procedure PollardRho;
var Num: RecNo;
begin
     repeat
            clrscr;
            for j:=1 to maxfatt do InitNo(fatt[j]);
            ind:= 1;
            gotoxy(4,4);
            Writeln('Scomposizione in fattori primi secondo l''euristica rho di Pollard');
            gotoxy(1,7);
            writeln('Inserisci il numero di cui cercare il fattore (0 per uscire)');
            Write('Num = '); ReadNo(Num);
            if CalcCfr(Num) <> 0 then
            begin
                 gotoxy(1,10);
                 if PollRho(num, ind) then
                 begin
                    write('Sono stati trovati ', ind-1,' fattori non banali di ');
                    WriteNo(Num); Writeln(':');
                 end
                 else
                 begin
                    write('Non sono stati trovati fattori non banali di ');
                    WriteNo(Num); Writeln;
                    writeln; writeln('il numero  forse primo')
                 end;
                 writeln;
                 for j:=1 to ind-1 do begin WriteNo(fatt[j]); Writeln end;
                 readln;
            end;
     until CalcCfr(num) = 0;
end;

Procedure Menu;
begin
     gotoxy(10, 3);
     Writeln('Progetto per il corso di Algoritmi e Strutture Dati II');
     gotoxy(17, 5); Writeln('Autori:   Luca Cinti      Lorenzo Masetti');
     gotoxy(2, 9); Writeln('Sono disponibili tre procedure: ');
     gotoxy(5, 11); Writeln('1. Verifica di Pseudo-Primalit');
     gotoxy(5, 13); Writeln('2. Verifica di Primalit di Miller Rabin');
     gotoxy(5, 15);
     Writeln('3. Ricerca di un fattore di un numero con la tecnica Pollard-Rho');
     gotoxy(2,18);
end;

begin
     Randomize;
     repeat
           Clrscr;
           Menu;
           write('Scelta (0 per uscire) > ');
           readln(Scelta);
           if scelta = 0 then exit;
           case scelta of
           1: Pseudo;
           2: Miller;
           3: PollardRho;
           end;
     until false;
end.
