program Simulazione;
uses crt, uprimi; 
const Max=65000;

const s=10; {Precisione di MillerRa} 
var primo, miller, pseudo : array[2..Max] of boolean; 
(*    NumProve : cardinal; *)

var errori : array[1..80] of cardinal;
var ie : integer;

Procedure GetCoords(var x,y : integer);
begin
x:=WhereX; y:=Wherey
end;


Procedure InitPrimo; 
var i,k : cardinal; 
    x,y : integer;
begin 
     Writeln('Ricerca dei numeri primi da 2 a ',Max);
     primo[2]:=true;
     i:=3;
     while i<=Max do begin
	primo[i]:=true;
	primo[i+1]:=false;
	i:=i+2;
	end;

  
     i:=3;  
     k:=9;  
     repeat  
	   Write('Escludo i multipli di ',i,':' );
           GetCoords(x,y);
           
	   while k<=Max do begin (*non sono primi i multipli di i (primo) a partire da k=i^2*)  
                 gotoxy(x,y);Write(k:9);
		 primo[k]:=false;  
                 k:=k+i;  
           end;  
           writeln;
           repeat  
                 i:=i+1  (*trova il prossimo numero primo*)  
           until primo[i];  
           k:=i*i;  
     until (k>Max);  
end; 

Procedure Riempi;
var i : cardinal;
var x,y : integer;
begin
	Writeln('Controllo i numeri dispari da 3 a ', Max);
	Write('Prova ');
	x:=WhereX; y:=WhereY;

	pseudo[2]:=true; miller[2]:=true;
	for i:=3 to Max do begin
		pseudo[i]:=false; miller[i]:=false;
		end;
	
	i:=3;
	while (i<=Max) do begin
		gotoxy(x,y); Write((i div 2):6,'/',(Max div 2));
		pseudo[i]:= not PseudoPrimo(i);
		miller[i]:= not MillerRa(i,s);
		i:=i+2;
		end;

end;

Procedure Confronto;
var i,
    countPseudo, countMiller, totprimi : longint;
	c : char;
begin
	countPseudo:=0; countMiller:=0; totprimi:=1;
	c:='a'; 
	i:=3; ie:=1;
	while i<=Max do begin
		if primo[i] then inc(TotPrimi);
		if pseudo[i] and not primo[i] then  begin
			inc(countPseudo);
			errori[ie]:=i;
			inc(ie);
			end;

		if miller[i] and not primo[i] then inc(countMiller);

        	if primo[i] and not pseudo[i] then begin
			Writeln('Errore Pseudo su ',i);
			if c<>'f' then readln(c);
			end; 
		if primo[i] and not miller[i] then
			Writeln('Errore Miller su ',i); 
		i:=i+2;
	     end;

	Writeln;
	writeln('- i numeri primi minori di ',Max,' sono ',TotPrimi);
	writeln('  (con l''approssimazione n/ln(n) si ottiene ',Max/ln(Max):2:0,')');
	Writeln('- la procedura pseudoprimo sbaglia ',countPseudo,' volte (rapporto ',countPseudo/TotPrimi:3:3,')');
	Writeln('- la procedura MillerRa sbaglia ',countMiller,' volte (rapporto ',countMiller/TotPrimi:3:3,')');
end;

begin
	ClrScr;
	InitPrimo;
	writeln;

	(*Write('Numero di prove (0-',Max,') >');
	repeat
		Readln(NumProve)
	until NumProve<=Max; *)

	Riempi;
	writeln;

	Confronto;
	writeln;
	Writeln('I numeri per i quali la procedura PseudoPrimo sbaglia sono');
	for j:=1 to (ie-1) do write(errori[j]:10);
	writeln;

end.






	



	
