program Verifiche;
uses crt, uprimi;
var scelta: integer;

Procedure pseudo;
var num: longint;
begin
     repeat
        clrscr;
        gotoxy(25,4); Writeln('Verifica di pseudo-primalita''');
        writeln; writeln;
        Write('Inserisci un numero per controllare se e'' primo (0 per uscire) > ');
        readln(num);
        if num = 0 then exit;
        writeln;
        if pseudoprimo(num) then writeln('il numero ', num, ' e'' composto')
        else writeln('il numero ', num, ' e'' primo (o pseudoprimo)');
        readln;
     until false;
end;

Procedure Miller;
var num: longint;
    s: integer;
begin
     num:= 1;
     repeat
           clrscr;
           gotoxy(20,4); Writeln('Verifica di primalita'' di Miller-Rabin');
           writeln; writeln;
           Write('Inserisci un numero per controllare se e'' primo (0 per uscire) > ');
           readln(num);
           s:= 10;
           if num <> 0 then
           begin
                writeln;
                if millerra(num, s) then writeln('il numero ', num, ' e'' composto')
                else
                begin
                     writeln('il numero ', num, ' e''primo');
                     writeln;
                     write('Il margine di errore di tale risultato e'' al piu'' = 2^(-',s, ') = ');
                     writeln(1/DueElevatoA(s):0:4);
                end;
                readln;
           end;
     until num=0;
end;

Procedure PollardRho;
begin
     repeat
            clrscr;
            for j:=1 to maxfatt do fatt[j]:= 0; ind:= 1;
            gotoxy(4,4);
            Writeln('Scomposizione in fattori primi secondo l''euristica rho di Pollard');
            gotoxy(1,7);
            write('Inserisci il numero di cui cercare il fattore (0 per uscire) > ');
            Readln(num);
            if num <> 0 then
            begin
                 gotoxy(1,10);
                 if PollRho(num) then
                    writeln('Sono stati trovati ', ind-1,' fattori non banali di ', num,':')
                    else begin
                         writeln('Non sono stati trovati fattori non banali di ', num);
                         writeln; writeln('il numero e'' forse primo')
                    end;
                 writeln;
                 for j:=1 to ind-1 do writeln(fatt[j]);
                 readln;
            end;
     until num = 0;
end;

Procedure Menu;
begin
     gotoxy(10, 3);
     Writeln('Progetto per il corso di Algoritmi e Strutture Dati II');
     gotoxy(17, 5); Writeln('Autori:   Luca Cinti      Lorenzo Masetti');
     gotoxy(2, 9); Writeln('Sono disponibili tre procedure: ');
     gotoxy(5, 11); Writeln('1. Verifica di Pseudo-Primalita''');
     gotoxy(5, 13); Writeln('2. Verifica di Primalita'' di Miller Rabin');
     gotoxy(5, 15);
     Writeln('3. Ricerca di un fattore di un numero con la tecnica Pollard-Rho');
     gotoxy(2,18);
end;

begin
     Randomize;
     repeat
           Clrscr;
           Menu;
           write('Scelta (0 per uscire) > ');
           readln(Scelta);
           if scelta = 0 then exit;
           case scelta of
           1: Pseudo;
           2: Miller;
           3: PollardRho;
           end;
     until false;
end.
